# Imports
import sys
from random import randint
import random


def generateComs():
    returnList = []

    # Create Lists - (Lecturers, modules)
    lecturers = list()
    for i in range(1, inLecturers + 1):
        lecturers.append("l" + str(i))
    modules = list()
    for i in range(1, inModules + 1):
        modules.append("cm00" + str(i))

    # Match a module to a unique lecturer
    modulesDict = dict()
    counter = 0
    while counter < len(modules):
        for i in range(0, len(lecturers)):
            if counter < len(modules):
                modulesDict[modules[counter]] = lecturers[i]
                counter += 1
            else:
                break

    # Generate multiple commitments for each module

    commitsLeft = commitments
    moduleCounter = 0

    for key in modulesDict:
        commitsPerModule = int(commitsLeft / (len(modules) - moduleCounter))
        if moduleCounter == len(modulesDict) - 1:
            for i in range(0, commitsLeft):
                returnList.append("[" + key + "," + modulesDict[key] + "]")
        else:
            thisCommitNumber = randint(commitsPerModule - 1, commitsPerModule + 1)
            for i in range(0, thisCommitNumber):
                returnList.append("[" + key + "," + modulesDict[key] + "]")
            commitsLeft = commitsLeft - thisCommitNumber
        moduleCounter += 1

    return returnList


def generateMods():
    returnList = []

    # Create student and module list
    students = list()
    for i in range(1, inStudents + 1):
        students.append("s" + str(i))
    modules = list()
    for i in range(1, inModules + 1):
        modules.append("cm00" + str(i))

    # Group students and modules
    groupedDict = dict()
    counter = 0
    studentsLeft = inStudents
    groupsLeft = groups
    modulesLeft = inModules
    while counter < groups:
        groupedDict[counter + 1] = [[], []]
        studentsPerGroup = studentsLeft/groupsLeft
        modulesPerGroup = modulesLeft/groupsLeft
        if(counter == groups - 1):
            numStudents = studentsLeft
            numModules = modulesLeft
            for i in range(0, int(numStudents)):
                groupedDict[counter + 1][1].append(students.pop())
            for i in range(0, int(numModules)):
                groupedDict[counter + 1][0].append(modules.pop())
        else:
            numStudents = randint(int(studentsPerGroup - (studentsPerGroup/5)), int(studentsPerGroup + (studentsPerGroup/5)))
            numModules = randint(int(modulesPerGroup - 1), int(modulesPerGroup + 1))
            for i in range(0, int(numStudents)):
                groupedDict[counter + 1][1].append(students.pop())#
            for i in range(0, int(numModules)):
                groupedDict[counter + 1][0].append(modules.pop())
        counter += 1
        studentsLeft = studentsLeft - numStudents
        modulesLeft = modulesLeft - numModules
        groupsLeft = groupsLeft - 1



    # Match students to modules
    for key in groupedDict: #for every group
        for i in range(0, len(groupedDict[key][0])):#for every module
            randomNum = len(groupedDict[key][1]) / 4
            elements = random.sample(groupedDict[key][1], int(randomNum))
            for j in range(0, len(elements)):
                returnList.append("[" + str(groupedDict[key][0][i]) + "," + str(elements[j]) + "]")#for every student

    return returnList

if __name__ == '__main__':

    # Command line arguments
    timeSlotsPerDay = int(sys.argv[1])
    daysPerWeek = int(sys.argv[2])
    inStudents = int(sys.argv[3])
    inModules = int(sys.argv[4])
    groups = int(sys.argv[5])
    commitments = int(sys.argv[6])
    rooms = int(sys.argv[7])
    inLecturers = int(sys.argv[8])

    # Generate text file
    f = open('newConfig.txt', 'w+')
    f.write("::start::\n")

    # Time slots
    times = ["09:00", "10:00", "11:00", "12:00", "13:00", "14:00", "15:00", "16:00", "17:00"]
    f.write("::ts::\n")
    for i in range(1, daysPerWeek + 1):
        for j in range(0, timeSlotsPerDay):
            f.write("[" + str(i) + "," + times[j] + "]\n")
    f.write("::ts::\n")

    # Commitments
    f.write("::c::\n")
    comList = generateComs()
    for line in comList:
        f.write(str(line) + "\n")
    f.write("::c::\n")

    # Modules
    f.write("::m::\n")
    modList = generateMods()
    for line in modList:
        f.write(str(line) + "\n")
    f.write("::m::\n")

    # Rooms
    f.write("::r::\n")
    for i in range(1, rooms + 1):
        f.write("room" + str(i) + "\n")
    f.write("::r::\n")

    # End file
    f.write("::end::")
    f.close()
    print(" ")
    print("Config file generated")
    print(" ")